﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using HeuristicLab.Collections;
using HeuristicLab.Common;
using HeuristicLab.Problems.DataAnalysis;
using HeuristicLab.Problems.Instances.DataAnalysis.Regression.Matlab.Api;
using HeuristicLab.Problems.Instances.DataAnalysis.Regression.Matlab.Api.Types;

namespace HeuristicLab.Problems.Instances.DataAnalysis.Views.Regression.Matlab {
  public partial class RegressionMatlabImportDialog {
    private interface IMLVariablesLoader {

      /// <summary>
      /// This event will be fired after the number of variables was changed.
      /// </summary>
      event EventHandler<EventArgs<int>> NumberOfSelectedVariablesChanged;

      /// <summary>
      /// This property contains the selected variables.
      /// </summary>
      IEnumerable<MLVariableInfo> SelectedVariables { get; }
          
      /// <summary>
      /// Returns a dataset which contains the data of the selected Matlab variables.
      /// </summary>
      /// <param name="mlConnector"></param>
      /// <returns></returns>
      Dataset GetPreviewDataset(IMatlabConnector mlConnector, CancellationToken token);

      /// <summary>
      /// Shows the given Variables at the list view.
      /// </summary>
      /// <param name="variables"></param>
      void DisplayVariables(IEnumerable<MLVariableInfo> variables);
    }
  }  
}
